#ifndef _MAIN_WINDOW_H
#define _MAIN_WINDOW_H

#include <gconf/gconf-client.h>
#include <glade/glade.h>

enum {
	FILENAME_COLUMN,
	URL_COLUMN,
	STATE_COLUMN,
	CURRENTSIZE_COLUMN,
	TOTALSIZE_COLUMN,
	PERCENTAGE_COLUMN,
	TOTALTIME_COLUMN,
	ELAPSETIME_COLUMN,
	CURRENTTIME_COLUMN,
	ESTIMATEDTIME_COLUMN,
	REMAINTIME_COLUMN,
	PID_COLUMN,
	STATE_INT_COLUMN,
	SPEED_COLUMN,
	NUM_COLUMNS
	
};


GladeXML *xml;

/* the model of the GtkTreeView */
/* declared here for be used to add by main_window_cb */
GtkTreeModel *model;

/* GConf Client */
GConfClient *gconf_client;

/* List of all current downloads */
GList *downloads;

void main_window(void);
void on_main_window_delete_event(GtkWidget *widget, gpointer data);
GtkTreeModel* create_model(void);
void add_columns (GtkTreeView *treeview);
void gwget2_get_defaults_from_gconf(void);
/* Drag received callback */
void on_treeview_drag_received(GtkWidget * widget, GdkDragContext * context, int x,
                     int y, GtkSelectionData * seldata, guint info,
                     guint time, gpointer data);

#endif
